<?php

Class OTProFunctions
{
    /*****pro*****/
    function print_form_builder()
    {
        ?>
        <div class="hero-unit" style="padding: 15px; font-size: 14px;">
            <div style="float:left;width:65%;">
                <h3>Form Builder</h3>
                <div id="myAlert" class="alert fade <?php echo $class ?>" data-alert="alert"><?php echo $message ?></div>
                <div class="span12">
                    <label class="control-label" style="width:25%;">Form Type</label>
                    <select name="form_type" id="form_type">
                        <option value="-1">Select One</option>
                        <option value="1">Standard Form</option>
                        <option value="2">Blog Form</option>
                        <option value="4">Question Form</option>
                    </select>
                </div>
                <div class="span12" style="margin-top:10px;">
                    <label class="control-label" style="width:25%;">Form HTML</label>
                    <textarea id="custom_form" class="customizer_textarea" name="custom_form"></textarea>
                </div>
                <div class="span12" style="margin-top:10px;">
                    <label class="control-label" style="width:25%;">Form CSS</label>
                    <textarea id="custom_css" class="customizer_textarea" name="custom_css"></textarea>
                </div>
                <div class="span12" style="margin-top:10px;">
                    <label class="control-label" style="width:25%;">Form Images</label>
            <span class="btn btn-success fileinput-button">
                    <i class="glyphicon glyphicon-plus"></i>
                    <span>ADD FILES...</span>
                    <!-- The file input field used as target for the file upload widget -->
                    <input id="fileupload" type="file" name="files[]" data-url="<?php echo OT_PLUGIN_URL; ?>/lib/uploader/php/" multiple>
                </span>

                    <p id="show_files"></p>
                    <script src="<?php echo OT_PLUGIN_URL; ?>/js/uploader/vendor/jquery.ui.widget.js"></script>
                    <script src="<?php echo OT_PLUGIN_URL; ?>/js/uploader/jquery.iframe-transport.js"></script>
                    <script src="<?php echo OT_PLUGIN_URL; ?>/js/uploader/jquery.fileupload.js"></script>
                    <script>
                        jQuery(function () {
                            jQuery('#fileupload').fileupload({
                                dataType: 'json',
                                done: function (e, data) {
                                    jQuery.each(data.result.files, function (index, file) {
                                        jQuery('<p/>').text(file.name).appendTo("#show_files");
                                    });
                                }
                            });
                        });
                    </script>

                </div>
                <div class="clear"></div>
                <button class="btn btn-primary" type="button" id="save-custom-form">SAVE</button>
            </div>
            <div style="float:right;width:35%;">
                <h3>Instructions</h3>

                <p>1. Paste HTML into the "Form HTML field", do not include &lt;body&gt; or &lt;html&gt; tags.</p>

                <p>2. Tag editable text with &lt;editText&gt; and &lt;/editText&gt;. Example: &lt;editText&gt;Text to make editable&lt;/editText&gt;.</p>

                <p>3. Set all image urls to '&lt;images&gt;your-image.jpg'.</p>

                <p>4. Replace your button with &lt;button&gt;. Your button class name should be ".submit_button{}". </p>

                <p>5. Paste CSS into the "Form CSS field".</p>

                <p>6. Upload all images associated with this form including a thumbnail image with the file name
                    <span id="file_name">...</span></p>

                <p>
                    <a href="admin.php?page=optin-tango-settings&tab=form_customizer&download=1&file=OptinTangoSampleForm.html" title="Download Sample Form">Download This Sample Form!</a>
                </p>
            </div>
            <div class="clear"></div>
            <div class="ot-help  bg-info">
                <h3>Need Help? </h3>

                <p>Learn how to bulid your own form
                    <a href="http://www.jvprogrammers.com/form-builder" target="_blank">here!</a></p>
            </div>
        </div>
    <?php
    }
    function print_blog_wizard()
    {
        $ot=new OptinTangoPro();

        if(!$ot->get_all_options())
        {
            $ot->start_up();
            die();
        }
        $blogbox=null;
        if(isset($_GET['edit'])&&$_GET['edit']>0)
        {
            $blogbox=$ot->get_blogbox_values($_GET['edit']);
        }
        ?>
        <div class="acc-wizard hero-unit" style="padding: 10px 0; font-size: 13px;display: table;width: 100%">
        <h3 style="margin-left:15px;">Easy Setup Wizard</h3>
        <div class="span12">
            <h4 id="wizard">Create an BLOG BOX FORM With Our Easy Set Up Wizard:</h4>
            <div id="myAlert" class="alert fade inactive" data-alert="alert"></div>

            <div class="accordion" id="po-accordion">
                <div class="accordion-group">
                    <div class="accordion-heading">
                        <a class="accordion-toggle" data-toggle="collapse" data-parent="#po-accordion" href="#select-list">
                            Step 1: Name Your Blog Box and Select a Form:
                        </a>
                    </div>
                    <div id="select-list" class="accordion-body in collapse" style="height: auto;">
                        <div class="accordion-inner" id="">
                            <div class="button-container">
                                <label class="control-label" style="padding-top:6px;text-align: left;width:25%;">Blog Box Name</label>
                                <input type="text" class="input-xlarge" name="form_set_name" placeholder="Enter a Name For This Blog Box" id="form_set_name" style="margin:0 15px;" value="<?php echo isset($blogbox['form_set_name'])?str_replace('-',' ',$blogbox['form_set_name']):''; ?>">
                            </div>
                            <div class="button-container">
                                <label class="control-label" style="padding-top:6px;text-align: left;width:25%;margin-right:15px;">Choose Form Set</label>
                                <select class="selectpicker" name="blog-form" id="b-form-picker" data-style="btn-info">
                                    <option value="-1">Choose a Form....</option>
                                    <?php
                                    $options=$ot->get_formset_options();
                                    if(isset($blogbox['form_id'])AND $blogbox['form_id']!='')
                                    {
                                        echo '<option value="'.$blogbox['form_id'].'" selected="selected">'.str_replace("-"," ",$blogbox['form_name']).'</option>';
                                    }
                                    ?>
                                    <?php echo $options; ?>
                                </select>
                            </div>
                            <button class="btn btn-primary" type="button" id="save-blog-ar" style="float:right;margin-bottom:10px;">NEXT STEP</button>
                            <div class="clear"></div>
                        </div>
                        <!--/.accordion-inner -->
                    </div>
                    <!-- /#select_list -->
                </div>
                <!-- /.accordion-group -->

                <div class="accordion-group">
                    <div class="accordion-heading">
                        <a class="accordion-toggle" data-toggle="collapse" data-parent="#po-accordion" href="#config_blog_form">
                            Step 2: Choose and Edit Your Blog Box Design:
                        </a>
                    </div>
                    <div id="config_blog_form" class="accordion-body collapse">
                        <div id="select_form" class="accordion-inner">
                            <?php
                            if(isset($_GET['edit'])&&$_GET['edit']!='')
                            {
                               $this->print_blog_box_images(0,1);
                                echo '<div id="edit-blog-form" style="margin:10px 0">';
                                echo $ot->get_blogbox_for_edit($blogbox['form_design']['form_name']);
                                echo '</div>';
                                echo '<div id="create_button">';
                                $ot->print_form_button_generator($blogbox);
                                echo '</div>';
                            }
                            else
                            {
                                $ot->print_blog_box_images(0);
                                echo '<div id="edit-blog-form" style="display:none;margin-top:10px;"></div>';
                                echo '<br>';
                                echo '<div id="create_button" display="none;">';
                                $ot->print_form_button_generator();
                                echo '<div>';
                            }

                            ?>

                            <div class="btn-group" style="float:right;">
                                <button class="btn btn-success" type="button" id="go-back-blog">CHANGE FORM</button>
                                <button class="btn btn-primary" type="button" id="save-blog-all">SAVE BLOG BOX</button>
                            </div>
                            <input type="hidden" id="edit_id" value="<?php echo isset($_GET['edit'])&&$_GET['edit']>0?$_GET['edit']:'0'; ?>"/>

                            <!--/.accordion-inner -->
                        </div>
                        <!-- /#viewpage -->
                    </div>
                    <!-- /.accordion-group -->
                    <script type="text/javascript">
                        jQuery(window).load(function () {
                            editbox_init();
                        });
                    </script>
                </div>

            </div>

            <div class="clear"></div>
            <div class="ot-help  bg-info">
                <h3>Need Help? </h3>

                <p>Learn how to create an blog form
                    <a href="http://www.jvprogrammers.com/blog-form-wizard" target="_blank">here!</a></p>
            </div>
        </div>
    <?php
    }
function print_question_wizard()
{
    $ot=new OptinTangoPro();

    if(!$ot->get_all_options())
    {
        $ot->start_up();
        die();
    }
    $questionset=$formset=$formset2=null;
    if(isset($_GET['edit'])&&$_GET['edit']>0)
    {
        $questionset=$ot->get_question_box_values($_GET['edit']);
        $formset=$ot->get_formset_values($questionset['form_id1']);
        $formset2=$ot->get_formset_values($questionset['form_id2']);
    }
    ?>
<div class="acc-wizard hero-unit" style="padding: 10px 0; font-size: 13px;display: table;width: 100%">
    <h3 style="margin-left:15px;">Easy QUESTION OPTIN Setup Wizard</h3>
<div class="span12">
    <h4 id="wizard">Create a QUESTION OPTIN FORM With Our Easy Set Up Wizard:</h4>
    <div id="myAlert" class="alert fade inactive" data-alert="alert"></div>

    <div class="accordion" id="po-accordion">
        <div class="accordion-group">
            <div class="accordion-heading">
                <a class="accordion-toggle" data-toggle="collapse" data-parent="#po-accordion" href="#question-settings">
                    Step 1: Question Set Settings:
                </a>
            </div>
            <div id="question-settings" class="accordion-body in collapse" style="height: auto;">
                <div class="accordion-inner" id="">

                    <div class="button-container">
                        <label class="control-label" style="padding-top:6px;text-align: left;width:25%;">Question Set Name</label>
                        <input type="text" class="input-xlarge" name="question_set_name" placeholder="Enter a Name For This Question Set" id="question_set_name" style="margin:0 15px;" value="<?php echo isset($questionset['question_set_name'])?str_replace('-',' ',$questionset['question_set_name']):''; ?>">
                    </div>
                    <div class="button-container">
                        <label class="control-label" style="padding-top:6px;text-align: left;width:25%;">Delay in Milliseconds</label>
                        <input type="text" class="input-small" name="question_seconds" placeholder="Enter a Delay in Milliseconds" id="question_seconds" style="margin:0 15px;" value="<?php echo isset($questionset['question_seconds'])?str_replace('-',' ',$questionset['question_seconds']):''; ?>">
                        (seconds x 1000)
                    </div>
                    <div class="button-container">
                        <label class="control-label" style="padding-top:6px;text-align: left;width:25%;margin-right:15px;">Choose Form One (Yes)</label>
                        <select class="selectpicker" name="blog-form" id="q-form1-picker">
                            <option value="-1">Choose Form 1....</option>
                            <?php
                            $options=$ot->get_formset_options();
                            if(isset($questionset['form_id1'])AND $questionset['form_id1']!='')
                            {
                                echo '<option value="'.$questionset['form_id1'].'" selected="selected">'.str_replace("-"," ",$questionset['form1_name']).'</option>';
                            }
                            ?>
                            <?php echo $options; ?>
                        </select>
                    </div>
                    <div class="button-container">
                        <label class="control-label" style="padding-top:6px;text-align: left;width:25%;margin-right:15px;">Choose Form Two (No)</label>
                        <select class="selectpicker" name="blog-form" id="q-form2-picker">
                            <option value="-1">Choose Form 2...</option>
                            <?php
                            $options=$ot->get_formset_options();
                            if(isset($questionset['form_id2'])AND $questionset['form_id2']!='')
                            {
                                echo '<option value="'.$questionset['form_id2'].'" selected="selected">'.str_replace("-"," ",$questionset['form2_name']).'</option>';
                            }
                            ?>
                            <?php echo $options; ?>
                        </select>
                    </div>
                    <input type="hidden" id="qid" value=""/>
                    <button class="btn btn-primary" type="button" id="save-question-s1" style="float:right;">NEXT STEP</button>
                    <div class="clear"></div>

                </div>
                <!--/.accordion-inner -->
            </div>
            <!-- /#select_list -->
        </div>
    </div>
    <!-- /.accordion-group -->
    <div class="accordion" id="po-accordion">
        <div class="accordion-group">
            <div class="accordion-heading">
                <a class="accordion-toggle" data-toggle="collapse" data-parent="#po-accordion" href="#question-form-config">
                    Step 2: Select Question From:
                </a>
            </div>
            <div id="question-form-config" class="accordion-body in collapse" style="height: auto;">
                <div class="accordion-inner" id="select-form">
                    <?php
                    if(isset($_GET['edit'])&&$_GET['edit']!='')
                    {
                        $ot->print_question_forms(1);
                        echo '<div id="edit_questions_form" style="margin-top:10px;">';
                        echo $ot->get_question_box_for_render($_GET['edit'],1);
                        echo '</div>';
                    }
                    else
                    {
                        $ot->print_question_forms();
                        echo '<div id="edit_questions_form" style="display:none;margin-top:10px;">';
                        echo '</div>';
                    }
                    ?>

                    <div class="btn-group" style="float:right;margin-top:20px;">
                        <button class="btn btn-success" type="button" id="go-back-question">CHANGE FORM</button>
                        <button class="btn btn-primary" type="button" id="save-question-form">SAVE QUESTION SET</button>
                    </div>
                    <div class="clear"></div>

                    <!--/.accordion-inner -->
                </div>
                <!-- /#select_list -->
            </div>
            <script type="text/javascript">
                jQuery(window).load(function () {
                    editbox_init();
                });
            </script>
        </div>
        <div class="clear"></div>
        <div class="ot-help  bg-info">
            <h3>Need Help? </h3>

            <p>Learn how to create a Question Form
                <a href="http://www.jvprogrammers.com/question-form-wizard" target="_blank">here!</a></p>

        </div>
        <!-- /.accordion-group -->

        <div class="clear"></div>
    </div>
<?php
}
    function print_blogbox_sets()
    {
        $ot=new OptinTangoPro();
        $settingsURL=OPTIN_TANGO_PLUGIN;
        if(isset($_GET['bid'])&&$_GET['bid']>0)
        {
            $ot->print_standalone_script($_GET['bid']);
        }
        $settings=$ot->get_settings('optin_tango_settings');
        $display_options=array('-1'=>'Choose One...','all-post'=>'All Posts','all-pages'=>'All Pages','all-post-pages'=>'All Post and Pages','only-selected'=>'I Will Choose in Post/Page Settings');
        ?>

        <div class="hero-unit" style="padding: 10px 20px 20px;">

            <h3>
                Manage Blog Forms
                <button id="button-settings" class="btn btn-small btn-inverse" style="margin-left:10px;float:right;">DEFAULT SETTINGS</button>
            </h3>
            <div id="button-settings-div">
                <form method="post" action="options.php" enctype="multipart/form-data" id="optin_tango_form1">
                    <?php settings_fields('optin_tango_settings'); ?>
                    <p>
                        <span>Default Blog Box:</span>
                        <select name="optin_tango_settings[box_default]" id="b-default-picker">
                            <?php echo $ot->get_blogbox_options(); ?>
                        </select>
                    </p>

                    <p>
                        <span>Display on:</span>
                        <select name="optin_tango_settings[box_settings]" id="b-display-picker">
                            <?php
                            foreach($display_options as $key=>$value)
                            {
                                $selected=null;
                                if($settings['box_settings']===$key)
                                {
                                    $selected='selected="selected"';
                                }
                                echo '<option value ="'.$key.'"'.$selected.'>'.$value.'</option>';
                            }
                            ?>
                        </select>
                    </p>
                    <input type="submit" value="Save" id="save_button" class="btn btn-primary"/>
                </form>
            </div>
            <table class="wp-list-table widefat fixed posts po-main" cellspacing="0">
                <thead>
                <tr>
                    <th style="width:250px;">
                        Blog Box Name
                    </th>
                    <th>&nbsp;</th>
                </tr>
                </thead>
                <tfoot>
                <tr>
                    <th>Blog Box Name</th>
                    <th></th>
                </tr>
                </tfoot>
                <tbody>
                <?php
                $blogboxes=$ot->get_blogboxes();
                global $wpdb;
                $rows=null;
                if($wpdb->num_rows<1)
                {
                    $rows.='<tr><td colspan="2" class="po-admin-row">No results found...<a href="admin.php?page='.$settingsURL.'-settings&tab=blog-wizard" class="btn btn-success">Create Blog Boxes</a></td></tr>';
                }
                foreach($blogboxes as $blogbox)
                {
                    $blogbox['form_set_name']=str_replace('-',' ',$blogbox['form_set_name']);
                    $blogbox['form_set_name']=ucfirst($blogbox['form_set_name']);
                    $rows.=<<<END
         <tr id="blogset_row_{$blogbox['id']}">
         <td class="po-admin-row">
            <div id="{$blogbox['id']}">{$blogbox['form_set_name']}</div>
         </td>
         <td class="po-admin-row">
            Shortcode:
            <input type="text" value="[optinTango bid={$blogbox['id']}]" readonly="readonly" style="margin-bottom: 0;text-align:center;"/>
            <div class="btn-group buttons-right">

                <!--<a href="admin.php?page=$settingsURL-settings&tab=formsets&bid={$blogbox['id']}" class="btn btn-info">Standalone Code</a>-->
                <a href="admin.php?page=$settingsURL-settings&tab=blog-wizard&edit={$blogbox['id']}" class="btn btn-success">Edit</a>
                <a href="javascript:void(0)" id="delete-blogbox" data-value="{$blogbox['id']}" class="delete-blogbox btn btn-danger">Delete</a>
            </div>
         </td>
         </tr>
END;
                }
                echo $rows;
                ?>
                </tbody>
            </table>
        </div>
    <?php
    }
    function print_question_box_sets()
    {
        $ot=new OptinTangoPro();
        
        $settingsURL=OPTIN_TANGO_PLUGIN;
        $settings=$ot->get_settings('optin_tango_settings');
        $display_options=array('-1'=>'Choose One...','all-post'=>'All Posts','all-pages'=>'All Pages','all-post-pages'=>'All Post and Pages','only-selected'=>'Do Not Display');
        ?>

        <div class="hero-unit" style="padding: 10px 20px 20px;">
            <h3>
                Manage Question Forms
                <button id="questionset-settings" data-value="{$formset['id']}" class="btn btn-small btn-inverse" style="margin-left:10px;float:right;">DEFAULT SETTINGS</button>
            </h3>
            <div id="questionset-settings-div">
                <form method="post" action="options.php" enctype="multipart/form-data" id="optin_tango_form1">
                    <?php settings_fields('optin_tango_settings'); ?>
                    <p>
                        <span>Delay in milliseconds:</span>
                        <input type="text" name="optin_tango_settings[question_delay]" value="<?php echo isset($settings['question_delay'])&&$settings['question_delay']>0?$settings['question_delay']:'2'; ?>" class="input-small"/>
                        (seconds x 1000) </p>

                    <p>
                        <span>Display on:</span>
                        <select name="optin_tango_settings[question_display]" id="q-display-picker">
                            <?php
                            foreach($display_options as $key=>$value)
                            {
                                $selected=null;
                                if($settings['question_display']===$key)
                                {
                                    $selected='selected="selected"';
                                }
                                echo '<option value ="'.$key.'"'.$selected.'>'.$value.'</option>';
                            }
                            ?>
                        </select>
                    </p>

                    <p id="default-q-box">
                        <span>Default Question Box:</span>
                        <select name="optin_tango_settings[question_default]" id="q-default-picker">
                            <option value="-1">Choose One</option>
                            <?php
                            $results=$ot->get_question_box_sets();
                            foreach($results AS $row)
                            {
                                $selected=null;
                                if($settings['question_default']===$row['id'])
                                {
                                    $selected='selected="selected"';
                                }
                                echo '<option value ="'.$row['id'].'"'.$selected.'>'.$row['question_set_name'].'</option>';
                            }
                            ?>
                        </select>
                    </p>
                    <input type="submit" value="Save" id="save_button" class="btn btn-primary"/>
                </form>
            </div>
            <table class="wp-list-table widefat fixed posts po-main" cellspacing="0">
                <thead>
                <tr>
                    <th style="width:250px;">Question Box Name</th>
                    <th></th>
                </tr>
                </thead>
                <tfoot>
                <tr>
                    <th>Question Box Name</th>
                    <th></th>
                </tr>
                </tfoot>
                <tbody>
                <?php
                global $wpdb;
                $questionsets=$ot->get_question_box_sets();
                $rows=null;
                if($wpdb->num_rows<1)
                {
                    $rows.='<tr><td colspan="2" class="po-admin-row">No results found...<a href="admin.php?page='.$settingsURL.'-settings&tab=question-wizard" class="btn btn-success">Create Quesiton Box Set</a></td></tr>';
                }
                foreach($questionsets as $questionset)
                {
                    $questionset['question_set_name']=str_replace('-',' ',$questionset['question_set_name']);
                    $questionset['question_set_name']=ucfirst($questionset['question_set_name']);
                    $rows.=<<<END
         <tr id="questionset_row_{$questionset['id']}">
         <td class="po-admin-row">
             <div id="{$questionset['id']}">{$questionset['question_set_name']}</div>
         </td>
         <td class="po-admin-row">
             <div class="btn-group buttons-right">
                 <a href="admin.php?page=$settingsURL-settings&tab=question-wizard&edit={$questionset['id']}" class="btn btn-success">Edit</a>
                 <a href="javascript:void(0)" id="delete-question-set" data-value="{$questionset['id']}" class="btn btn-danger delete-question-set">Delete</a>
             </div>
         </td>
         </tr>
END;
                }
                echo $rows;?>
                </tbody>
            </table>
        </div>
    <?php
    }
    function print_blog_tracking()
    {
        $ot=new OptinTangoPro();
        
        $blogstats=$ot->get_all_for_blog_tracking();
        $brows=$ar_type=null;
        if(count($blogstats)>0)
        {
            foreach($blogstats AS $stat)
            {
                $percent=0;
                if($stat['visits']>0)
                {
                    $percent=($stat['conversions']/$stat['visits']*100);
                    $percent=round($percent,3);
                }
                $brows.=<<<END
      <tr>
        <td style="text-align:left">{$stat['form_set_name']}</td>
        <td style="text-align:left">{$stat['form_name']}</td>
        <td class="po-center">{$stat['views']}</td>
        <td class="po-center">{$stat['visits']}</td>
        <td class="po-center">{$stat['conversions']}</td>
        <td class="po-center">$percent %</td>
      </tr>
END;
            }
        }
        else
        {
            $brows.='<tr><td colspan="6">No results found...</td></tr>';
        }?>
        <div class="hero-unit" style="padding: 10px 20px 20px;">

            <h3>
                Blog Box Tracking
            </h3>

            <table class="wp-list-table widefat fixed posts po-main" cellspacing="0">
                <thead>
                <tr>
                    <th style="width:200px;text-align:left;">
                        Blog Box name
                    </th>
                    <th style="width:200px;text-align:left;">
                        Form Set Name
                    </th>
                    <th class="po-center">Views</th>
                    <th class="po-center">Visits</th>
                    <th class="po-center">Conversions</th>
                    <th class="po-center">%</th>
                </tr>
                </thead>

                <tbody>
                <?php echo $brows; ?>
                </tbody>
            </table>
        </div>
    <?php
    }
    function print_qbox_tracking()
    {
        $ot=new OptinTangoPro();
        
        $questionstats=$ot->get_all_for_qbox_tracking();
        $qrows=$ar_type=null;
        if(count($questionstats)>0)
        {
            foreach($questionstats AS $stat)
            {
                $form1stats=$ot->get_form_tracking($stat['form1'],$stat['set_id'],5);
                $form2stats=$ot->get_form_tracking($stat['form2'],$stat['set_id'],5);
                $f1stat['visits']=$f2stat['visits']=$frows=null;
                if(count($form1stats)>0)
                {
                    foreach($form1stats as $f1stat)
                    {
                        $f1percent=0;
                        if($f1stat['visits']>0)
                        {
                            $f1percent=($f1stat['conversions']/$f1stat['visits']*100);
                            $f1percent=round($f1percent,3);
                        }
                        switch($f1stat['ar_type'])
                        {
                            case 1:
                                $ar_type='Aweber';
                                break;
                            case 2:
                                $ar_type='GetResponse';
                                break;
                            case 3:
                                $ar_type='SendReach';
                                break;
                            case 4:
                                $ar_type='MailChimp';
                                break;
                            case 5:
                                $ar_type='iContact';
                                break;
                        }
                        $frows.=<<<END
        <tr>
            <td>{$f1stat['form_set_name']}</td>
            <td>$ar_type</td>
            <td>{$f1stat['ar_list']}</td>
            <td class="po-center">{$f1stat['views']}</td>
            <td class="po-center">{$f1stat['visits']}</td>
            <td class="po-center">{$f1stat['conversions']}</td>
            <td class="po-center">$f1percent</td>
        </tr>
END;
                    }
                }
                else
                {
                    $frows.='<tr><td colspan="7">No results found at this time.</td></tr>';
                }
                if(count($form2stats)>0)
                {
                    foreach($form2stats as $f2stat)
                    {
                        $f2percent=0;
                        if($f2stat['visits']>0)
                        {
                            $f2percent=($f2stat['conversions']/$f2stat['visits']*100);
                            $f2percent=round($f2percent,3);
                        }
                        switch($f2stat['ar_type'])
                        {
                            case 1:
                                $ar_type2='Aweber';
                                break;
                            case 2:
                                $ar_type2='GetResponse';
                                break;
                            case 3:
                                $ar_type2='SendReach';
                                break;
                            case 4:
                                $ar_type='MailChimp';
                                break;
                            case 5:
                                $ar_type='iContact';
                                break;
                        }
                        $frows.=<<<END
        <tr>
           <td>{$f2stat['form_set_name']}</td>
           <td>$ar_type2</td>
           <td>{$f2stat['ar_list']}</td>
           <td class="po-center">{$f2stat['views']}</td>
           <td class="po-center">{$f2stat['visits']}</td>
           <td class="po-center">{$f2stat['conversions']}</td>
           <td class="po-center">$f2percent</td>
        </tr>
END;
                    }
                }
                else
                {
                    $frows.='<tr><td colspan="7">No results found at this time.</td></tr>';
                }
                $conversions=$f2stat['conversions']+$f1stat['conversions'];
                $percent=0;
                if($stat['visits']>0)
                {
                    $percent=($conversions/$stat['visits']*100);
                    $percent=round($percent,3);
                }
                $qrows.=<<<END
        <tr>
           <td style="text-align:left">{$stat['question_set_name']}</td>
           <td class="po-center">{$stat['views']}</td>
           <td class="po-center">{$stat['visits']}</td>
           <td class="po-center">$conversions</td>
           <td class="po-center">$percent %</td>
           <td>
               <button class="clickme btn btn-primary buttons-right">Expand Stats</button>
           </td>
        </tr>
END;
                $qrows.=<<<END
        <tr class="hideme">
        <td colspan="6" style="padding:0!important;border:none;">
           <div style="margin:15px;">
               <table class="wp-list-table widefat fixed posts po-small" cellspacing="0">
                    <thead>
                    <tr>
                       <th style="width:250px;">Form Name</th>
                       <th>Autoresponder</th>
                       <th>List Name</th>
                       <th class="po-center">Views</th>
                       <th class="po-center">Visits</th>
                       <th class="po-center">Conversions</th>
                       <th class="po-center">%</th>
                   </tr>
                   </thead>
                   $frows
               </table>
           </div>
        </td>
        </tr>
END;
            }
        }
        else
        {
            $qrows.='<tr><td colspan="6">No results found...</td></tr>';
        }?>
        <div class="hero-unit" style="padding: 10px 20px 20px;">

            <h3>
                Question Box Tracking
            </h3>

            <table class="wp-list-table widefat fixed posts po-main" cellspacing="0">
                <thead>
                <tr>
                    <th style="width:250px;text-align:left;">
                        Question Box Name
                    </th>
                    <th class="po-center">Views</th>
                    <th class="po-center">Visits</th>
                    <th class="po-center">Conversions</th>
                    <th class="po-center">%</th>
                    <th>&nbsp;</th>

                </tr>
                </thead>

                <tbody>
                <?php echo $qrows; ?>
                </tbody>
            </table>
        </div>
    <?php
    }
    /*****pro*****/
}

?>